<?php
if(!defined('IN_DISCUZ')) {

	exit('Access Denied');

}
require_once 'xh_alipay_api.php';
class xh_alipay_pay extends api_pay{

	protected $config;

	protected $ismobile = false;

	public function __construct() {

		parent::__construct();

		$this->config = $this->getconfig();

	}

	public function setorder($order_id, $price, $subject, $body, $showurl){

		global $_G;

		$data=array(
		    'mchid'     	=> $this->config['mchid'],
            'out_trade_no'	=> $order_id,
            'type'  		=> 'alipay',
            'total_fee' 	=> $price*100,
            'body'  		=> "#$order_id",
            'notify_url'	=> $_G['siteurl'].'source/plugin/dc_pay/api/xh_alipay/xh_alipay_notify.php',
            'nonce_str' 	=> str_shuffle(time())
		);
		$hashkey          = $this->config['private_key'];
		$data['sign']     = XH_Payment_Api::generate_xh_hash($data,$hashkey);
		$url=$this->config['transaction_url'].'/pay/payment';
		$response   	  = XH_Payment_Api::http_post_json($url, json_encode($data));
        $result     	  = $response?json_decode($response,true):null;
        $data['hashkey']  = $hashkey;
        if(!$result){
           exit('Internal server error');
        }
        $sign       	  = XH_Payment_Api::generate_xh_hash($result,$hashkey);
        if(!isset( $result['sign'])|| $sign!=$result['sign']){
            exit('Invalide Sign!!!');
        }
        $pay_url =$result['code_url'];
         ?>
			<!DOCTYPE html>
			<html>
			<head>
		    <meta charset="utf-8">
		    <meta http-equiv="X-UA-Compatible" content="IE=edge">
		    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
		    <meta name="keywords" content="">
		    <meta name="description" content="">   
		    <title>支付宝收银台</title>
		    <style>
		         *{margin:0;padding:0;}
		          body{background: #f2f2f4;}
		         .clearfix:after { content: "."; display: block; height: 0; clear: both; visibility: hidden; }
		        .clearfix { display: inline-block; }
		        * html .clearfix { height: 1%; }
		        .clearfix { display: block; }
		          .xh-title{height:75px;line-height:75px;text-align:center;font-size:30px;font-weight:300;border-bottom:2px solid #eee;background: #fff;}
		          .qrbox{max-width: 900px;margin: 0 auto;padding:85px 20px 20px 50px;}
		          
		          .qrbox .left{width: 40%;
		            float: left;    
		             display: block;
		            margin: 0px auto;}
		          .qrbox .left .qrcon{
		            border-radius: 10px;
		            background: #fff;
		            overflow: visible;
		            text-align: center;
		            padding-top:25px;
		            color: #555;
		            box-shadow: 0 3px 3px 0 rgba(0, 0, 0, .05);
		            vertical-align: top;
		            -webkit-transition: all .2s linear;
		            transition: all .2s linear;
		          }
		            .qrbox .left .qrcon .logo{width: 100%;}
		            .qrbox .left .qrcon .title{font-size: 16px;margin: 10px auto;width: 100%;}
		            .qrbox .left .qrcon .price{font-size: 22px;margin: 0px auto;width: 100%;}
		            .qrbox .left .qrcon .bottom{border-radius: 0 0 10px 10px;
		            width: 100%;
		            background: #32343d;
		            color: #f2f2f2;padding:15px 0px;text-align: center;font-size: 14px;}
		           .qrbox .sys{width: 60%;float: right;text-align: center;padding-top:20px;font-size: 12px;color: #ccc}
		           .qrbox img{max-width: 100%;}
		           @media (max-width : 767px){
		        .qrbox{padding:20px;}
		            .qrbox .left{width: 90%;float: none;}   
		            .qrbox .sys{display: none;}
		           }
		           
		           @media (max-width : 320px){
		
		          }
		          @media ( min-width: 321px) and ( max-width:375px ){
		
		          }
		    </style>
		    </head>
		    
		    <body>
		     <div class="xh-title">支付宝收银台</div>
		      <div class="qrbox clearfix">
		      <div class="left">
		         <div class="qrcon">
		           <h5><img src="/source/plugin/dc_pay/api/xh_alipay/images/alipay/logo.png" alt=""></h5>
		             <div class="title"><?php echo $data['body'] ?></div>
		             <div class="price"><?php echo $price?></div>
		             <div align="center"><div id="alipay_qrcode" style="width: 250px;height: 250px;"></div></div>
		             <div class="bottom">
		                 	请使用支付宝收银台扫一扫<br/>
		    				扫描二维码支付
		             </div>
		         </div>
		         
		  </div>
		     <div class="sys"><img src="/source/plugin/dc_pay/api/xh_alipay/images/alipay/alipay-sys.png" alt=""></div>
		  </div>
			 <script src="/source/plugin/dc_pay/api/xh_alipay/js/jquery-2.1.4.min.js"></script>
		     <script src="/source/plugin/dc_pay/api/xh_alipay/js/qrcode.js"></script>
		     <script type="text/javascript">
		     (function($){
		    		window.view={
						query:function () {
							var data={data:'<?php echo json_encode($data);?>'};
					        $.ajax({
					            type: "POST",
					            url: "/source/plugin/dc_pay/api/xh_alipay/xh_alipay_query.php?out_trade_no=<?php echo $order_id ?>",
					            timeout:6000,
					            data:data,
					            cache:false,
					            dataType:'text',
					            success:function(e){
					            		if (e && e.indexOf('complete')!==-1) {
		    			                $('#weixin-notice').css('color','green').text('已支付成功，跳转中...');
		    		                    window.location.href = "<?php echo $_G['siteurl'].'plugin.php?id=dc_pay:return&orderid='.$order_id ?>";
		    		                    return;
		    		                }
					                setTimeout(function(){window.view.query();}, 2000);
					            },
					            error:function(){
					            	 setTimeout(function(){window.view.query();}, 2000);
					            }
					        });
					    }
		    		};
		    		var qrcode = new QRCode(document.getElementById("alipay_qrcode"), {
		              width : 220,
		              height : 220
		            });
		            
		            <?php if(!empty($pay_url)){
		              ?>
		              qrcode.makeCode("<?php print $pay_url?>");
		              window.view.query();
		            <?php 
		            }?>
		    		
		    	})(jQuery);
		    	</script>
			</body>
		</html>
			<?php  
			exit;
	}

	public function getpayinfo(){
		$data=(array)json_decode(file_get_contents('php://input'));
		define('TRADENO', isset($data['order_id'])?$data['order_id']:null);
		define('ORDERID', isset($data['out_trade_no'])?$data['out_trade_no']:$_GET['orderid']);
		return array(
			'succeed'=>'success',
			'fail'=>'fail'
		);

	}

	public function pricecheck(){
	    return true;
	}

	public function notifycheck(){
	    $data=(array)json_decode(file_get_contents('php://input'));
	    if($data){
	    	return true;
	    }
	    return false;
	}

}

class xh_alipay_mobilepay extends xh_alipay_pay{

	public function __construct() {

		parent::__construct();

		$this->ismobile = true;

	}
	
	public function setorder($order_id, $price, $subject, $body, $showurl){
	    global $_G;

	    $data=array(
	        'mchid'     	=> $this->config['mchid'],
            'out_trade_no'	=> $order_id,
            'type'  		=> 'alipay',
            'total_fee' 	=> $price*100,
            'body'  		=> "#$order_id",
            'notify_url'	=> $_G['siteurl'].'source/plugin/dc_pay/api/xh_alipay/xh_alipay_notify.php',
            'redirect_url'  => $_G['siteurl'].'plugin.php?id=dc_pay:return&orderid='.$order_id,
            'nonce_str' 	=> str_shuffle(time())
	    );
	    $url=$this->config['transaction_url'];
	    $hashkey          = $this->config['private_key'];
	    $data['hash']     = XH_Payment_Api::generate_xh_hash($data,$hashkey);
        $pay_url     = XH_Payment_Api::data_link($url.'/alipaycashier', $data);
	    header("Location:". htmlspecialchars_decode($pay_url,ENT_NOQUOTES));
	    exit;
	}
	
	public function getpayinfo(){
		$data=(array)json_decode(file_get_contents('php://input'));
		define('TRADENO', isset($data['order_id'])?$data['order_id']:null);
		define('ORDERID', isset($data['out_trade_no'])?$data['out_trade_no']:$_GET['orderid']);
		return array(
			'succeed'=>'success',
			'fail'=>'fail'
		);

	}
	
	public function pricecheck(){
	    return true;
	}

	public function notifycheck(){
	    $data=(array)json_decode(file_get_contents('php://input'));
	    if($data){
	    	return true;
	    }
	    return false;
	}

}

?>
